"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Config_1 = require("../config/Config");
const ClassName_1 = require("./ClassName");
const Requires_1 = require("./Requires");
const Uses_1 = require("./Uses");
const Extend_1 = require("./Extend");
class BaseClass extends Config_1.default {
    get pathToFile() {
        return this.name.pathToFile;
    }
    constructor(name, options) {
        super(options);
        this.name = new ClassName_1.default(name, this);
        if (!this.has('extend'))
            this.push(new Extend_1.default);
        if (!this.has('requires'))
            this.push(new Requires_1.default);
        if (!this.has('uses'))
            this.push(new Uses_1.default);
        this.requires = this.find('requires');
        this.uses = this.find('uses');
        this.extend = this.find('extend');
        this.extend.cls = this;
    }
    /**
     * Инициализация запускается после добавления класса в менеджер классов.
     */
    init() { }
    toJavaScript() {
        return `Ext.define('${this.name.fullName}', ${super.toJavaScript()});`;
    }
    clone() {
        return new BaseClass(this.name.value + 'Clone', this.options.map(o => o.clone()));
    }
}
exports.default = BaseClass;
