"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const Formatter_1 = require("../Formatter");
// { name: string, fileName: string, text: string }
class ClassManager {
    constructor(namespace) {
        this.namespace = namespace;
        this.classes = [];
    }
    push(oneClassOrClassArray) {
        const classArray = _.isArray(oneClassOrClassArray) ? oneClassOrClassArray : [oneClassOrClassArray];
        classArray.forEach(cls => cls.classManager = this);
        this.classes = this.classes.concat(classArray);
        classArray.forEach(cls => cls.init());
        //cls.classManager = this;
        //this.classes.push(cls);
        return oneClassOrClassArray;
    }
    find(name) {
        return this.classes.find(cls => {
            return cls.name.localName == name || cls.name.fullName == name;
        });
    }
    has(name) {
        return !!this.find(name);
    }
    toJavaScript(options = {}) {
        return this.classes.map(cls => ({
            name: cls.name.fullName,
            fileName: cls.pathToFile,
            text: options.pretty ? Formatter_1.default.prettyFormat(cls.toJavaScript()) : cls.toJavaScript()
        }));
    }
}
exports.default = ClassManager;
