"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ClassName {
    constructor(value, cls) {
        this.cls = cls;
        this.path = [];
        this.value = value;
    }
    get value() {
        return this._value;
    }
    set value(value) {
        if (value.indexOf('.') != -1) {
            let splited = value.split('.');
            this.path = splited.splice(0, splited.length - 1);
            value = splited.pop();
        }
        this._value = value;
    }
    /**
     * Namespace + path.
     */
    get namespace() {
        return [this.cls.classManager.namespace, this.path.join('.')].filter(p => p).join('.');
    }
    /**
     * Namespace + path + Name.
     */
    get fullName() {
        return [this.namespace, this.value].join('.');
    }
    /**
     * path + Name.
     */
    get localName() {
        return [this.path.join('.'), this.value].filter(p => p).join('.');
    }
    /**
     * Директория файла класса: path через слеши.
     */
    get dirName() {
        return this.path.join('/');
    }
    /**
     * Имя файла: Name.js
     */
    get fileName() {
        return `${this.value}.js`;
    }
    /**
     * Путь с именем файла: path / Name.js
     */
    get pathToFile() {
        return [this.dirName, this.fileName].join('/');
    }
}
exports.default = ClassName;
