"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const OptionString_1 = require("../config/option/OptionString");
class Extend extends OptionString_1.default {
    constructor() {
        super({
            name: 'extend',
            skipIfEmpty: true
        });
    }
    getValue() {
        return (_.isFunction(this.value) ?
            this.value(this.cls) :
            (this.withNamespace(this.value) ?
                this.value :
                [this.cls.classManager.namespace, this.value].join('.')));
    }
    /**
     * Вспомогательная функция для проверки, есть ли в имени класса имя пространства.
     * Проверка основана на большой букве. Если первая буква большая, значит имя пространства в имя класса уже включено.
     */
    withNamespace(className) {
        return className[0] == className[0].toUpperCase();
    }
    get isEmpty() {
        return _.isString(this.getValue()) ? !this.getValue().trim() : true;
    }
    valueToJavaScript() {
        return OptionString_1.default.valueToJavaScript(this.getValue());
    }
    clone() {
        const clone = new Extend();
        clone.cls = this.cls;
        clone.value = this.value;
        return clone;
    }
}
exports.default = Extend;
