"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const BaseClass_1 = require("../BaseClass");
const Fields_1 = require("./Fields");
const HasOne_1 = require("./schema/HasOne");
const HasMany_1 = require("./schema/HasMany");
const Proxy_1 = require("./proxy/Proxy");
class ModelClass extends BaseClass_1.default {
    constructor(name, options) {
        super(name, options);
        if (!this.has('proxy'))
            this.push(new Proxy_1.default);
        if (!this.has('fields'))
            this.push(new Fields_1.default);
        if (!this.has('hasOne'))
            this.push(new HasOne_1.default);
        if (!this.has('hasMany'))
            this.push(new HasMany_1.default);
        this.proxy = this.find('proxy') || new Proxy_1.default;
        this.fields = this.find('fields') || new Fields_1.default;
        this.hasOne = this.find('hasOne') || new HasOne_1.default;
        this.hasMany = this.find('hasMany') || new HasMany_1.default;
    }
    clone() {
        return new ModelClass(this.name.value + 'Clone', this.options.map(o => o.clone()));
    }
}
exports.default = ModelClass;
