"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Comment {
    constructor(text = '') {
        this.text = text;
    }
    get isEmpty() {
        return !this.text.trim();
    }
    get isMultiLine() {
        return this.text.indexOf(Comment.EOL) != -1;
    }
    get valueAsArray() {
        return this.text.split(Comment.EOL).map(str => str.trim());
    }
    toJavaScript() {
        let result = [];
        const valueAsArray = this.isMultiLine ? this.valueAsArray : [this.text];
        // result.push('/**');
        // result = result.concat(valueAsArray.map(str => ` * ${str}`));
        // result.push(' */');
        result.push('// **');
        result = result.filter(str => str.trim()).concat(valueAsArray.map(str => `// * ${str}`));
        result.push('// *');
        return result.join(Comment.EOL);
    }
}
Comment.EOL = '\n';
exports.default = Comment;
