"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class OptionComment {
    constructor(text = '') {
        this.text = text;
    }
    get isEmpty() {
        return !this.text.trim();
    }
    get isMultiLine() {
        return this.text.indexOf(OptionComment.EOL) != -1;
    }
    get valueAsArray() {
        return this.text.split(OptionComment.EOL).map(str => str.trim());
    }
    toJavaScript() {
        let result = [];
        const valueAsArray = this.isMultiLine ? this.valueAsArray : [this.text];
        result.push('/**');
        result = result.concat(valueAsArray.map(str => ` * ${str}`));
        result.push(' */');
        return result.join(OptionComment.EOL);
    }
}
OptionComment.EOL = '\n';
exports.default = OptionComment;
