"use strict";
// УДАЛИТЬ
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const Config_1 = require("../Config");
class OptionValue {
    constructor(data) {
        this.data = data;
    }
    static toJavaScript(value) {
        switch (value.type) {
            case 'function': return value.data.toString();
            case 'string': return `"${value.data}"`;
            case 'config': return value.data.toJavaScript();
            case 'object': return new Config_1.default([value.data]).toJavaScript();
            case 'array': return `[${value.data.map(item => OptionValue.toJavaScript(new OptionValue(item))).join(', ')}]`;
            default: return `${value.data}`;
        }
    }
    get isString() {
        return _.isString(this.data);
    }
    get isFunction() {
        return _.isFunction(this.data);
    }
    get isConfig() {
        return this.data instanceof Config_1.default;
    }
    get isPlainObject() {
        return _.isPlainObject(this.data);
    }
    get isArray() {
        return _.isArray(this.data);
    }
    get type() {
        if (this.isString)
            return 'string';
        else if (this.isFunction)
            return 'function';
        else if (this.isConfig)
            return 'config';
        else if (this.isPlainObject)
            return 'object';
        else if (this.isArray)
            return 'array';
        else
            return 'undefined';
    }
    toJavaScript() {
        return OptionValue.toJavaScript(this);
    }
}
exports.default = OptionValue;
