"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const Config_1 = require("./Config");
class Option {
    constructor(data) {
        this.comment = new Comment;
        this.name = data.name;
        //this.value = data.value instanceof OptionValue ? data.value : new OptionValue(data.value);
        if ('value' in data)
            this.value = data.value;
        //if ('comment' in data) this.comment = data.comment instanceof Comment ? data.comment : new Comment(data.comment);
        this.skipIfEmpty = !!data.skipIfEmpty;
    }
    static valueToJavaScript(dataValue) {
        return ``;
    }
    static type(dataValue) {
        if (this.isString(dataValue))
            return 'string';
        else if (this.isFunction(dataValue))
            return 'function';
        else if (this.isConfig(dataValue))
            return 'config';
        else if (this.isPlainObject(dataValue))
            return 'object';
        else if (this.isArray(dataValue))
            return 'array';
        else
            return 'undefined';
    }
    static isString(dataValue) {
        return _.isString(dataValue);
    }
    static isFunction(dataValue) {
        return _.isFunction(dataValue);
    }
    static isConfig(dataValue) {
        return dataValue instanceof Config_1.default;
    }
    static isPlainObject(dataValue) {
        return _.isPlainObject(dataValue);
    }
    static isArray(dataValue) {
        return _.isArray(dataValue);
    }
    // get isSkip(): boolean {
    // 	return false;
    // }
    get isSkip() {
        return this.skipIfEmpty ? this.isEmpty : false;
    }
    get isEmpty() {
        return false;
    }
    toJavaScript() {
        return 'result.join(Formatter.EOL)';
    }
    valueToJavaScript() {
        return Option.valueToJavaScript(this.value);
    }
}
exports.default = Option;
