"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const sencha_extjs_generator_1 = require("sencha-extjs-generator");
let classManager = new sencha_extjs_generator_1.ClassManager('Namespace.sample');
// Тестовые примеры классов.
let class1 = new sencha_extjs_generator_1.BaseClass('Class1');
classManager.push(class1);
let modelClass2 = new sencha_extjs_generator_1.ModelClass('ModelClass2');
classManager.push(modelClass2);
let modelClass3 = new sencha_extjs_generator_1.ModelClass('ModelClass3');
classManager.push(modelClass3);
let modelClass4 = new sencha_extjs_generator_1.ModelClass('ModelClass4');
classManager.push(modelClass4);
modelClass4.proxy.value = new sencha_extjs_generator_1.Config([{
        name: 'serviceMethod',
        value: 'getPaymentsHistoryByDebtor'
    }, {
        name: 'reader',
        value: new sencha_extjs_generator_1.Config([{
                name: 'rootProperty',
                value: 'result.ResultItems'
            }])
    }]);
class1.name.path.push('subdir');
class1.requires.comment.text = 'Зависимости класса.';
class1.requires.push('Namespace.sample.Class2');
class1.requires.push('Namespace.sample.Class3');
class1.requires.push('Namespace.sample.Class4');
class1.requires.push('Namespace.sample.Class22');
class1.requires.push('Namespace.sample.Class32');
class1.requires.push('Namespace.sample.Class42');
class1.uses.push('Namespace.sample.Class41');
class1.uses.push('Namespace.sample.Class42');
class1.uses.push('Namespace.sample.Class43');
modelClass2.name.path.push('data');
modelClass2.extend.value = 'Class2';
modelClass2.fields.push([new sencha_extjs_generator_1.Config([{
            name: 'name',
            value: 'field1'
        }, {
            name: 'mapping',
            value: 'Field1'
        }]), {
        name: 'name',
        value: 'field2'
    }]);
modelClass2.hasOne.push(new sencha_extjs_generator_1.Config([{
        name: 'role',
        value: 'agreementType'
    }, {
        name: 'reader',
        value: new sencha_extjs_generator_1.Config([{
                name: 'rootProperty',
                value: 'AgreementType'
            }, {
                name: 'typeProperty',
                comment: 'Тип узла.',
                code: `function(rawNode) {
			var namespace = "Pir.server.model.baseModel.type";
			return "type" in rawNode ? namespace + ".T" + rawNode.type : undefined;
		}`
            }])
    }]));
let hasMany1 = new sencha_extjs_generator_1.Config([{
        name: 'fdsfdsfdsf',
        value: 'fdfdsfdfdsf'
    }]);
hasMany1.push({
    name: 'vcxvcxvxc',
    value: 43432423 // TODO сделать, чтобы числа тоже можно было вводить, сейчас в выходном коде undefined.
});
modelClass2.hasMany.push(hasMany1);
modelClass3.extend.value = function () {
    return "Вычисленный родительский класс";
};
let foundClass = classManager.find('data.ModelClass2');
if (!foundClass)
    throw new Error(`Класс 'data.ModelClass2' не найден.`);
foundClass.proxy.value = new sencha_extjs_generator_1.Config([{
        name: 'serviceMethod',
        value: 'getDebtorsBySearchParams'
    }]);
// Клонирование класса.
let modelClass2Clone = modelClass2.clone();
modelClass2Clone.name.value = 'Склонированный класс';
modelClass2Clone.extend.value = 'Наследование склонированного класса';
classManager.push(modelClass2Clone);
// Тестирование ввода конфига.
let conf = new sencha_extjs_generator_1.Config([{
        name: 'fdsf'
    }]);
conf.push({
    name: '',
    code: ''
});
// conf.toJavaScript()
// Вывод классов.
const prettyFormatEnable = true;
const EOL = '\n';
let divider = '';
for (let i = 0; i < 100 / 2; i++)
    divider += '— ';
console.log(EOL + divider + EOL);
console.log('Namespace = ', classManager.namespace + EOL);
classManager.toJavaScript({
    pretty: prettyFormatEnable
}).forEach(item => {
    console.log(divider + EOL);
    console.log('Class name =', item.name);
    console.log('File name =', item.fileName, EOL);
    console.log(item.text);
});
// classManager.classes.forEach(cls => {
// 	console.log(divider + EOL);
// 	console.log('File name =', cls.pathToFile + EOL);
// 	if (prettyFormatEnable) {
// 		console.log(Formatter.prettyFormat(cls.toJavaScript()));
// 	} else {
// 		console.log(cls.toJavaScript());
// 	}
// });
console.log(divider + EOL);
